package cn.iocoder.yudao.module.member.service.activityawards;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activityawards.vo.ActivityAwardsPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.activityawards.vo.ActivityAwardsSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activityawards.ActivityAwardsDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 活动奖项 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityAwardsService {

    /**
     * 创建活动奖项
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivityAwards(@Valid ActivityAwardsSaveReqVO createReqVO);

    /**
     * 更新活动奖项
     *
     * @param updateReqVO 更新信息
     */
    void updateActivityAwards(@Valid ActivityAwardsSaveReqVO updateReqVO);

    /**
     * 删除活动奖项
     *
     * @param id 编号
     */
    void deleteActivityAwards(Long id);

    /**
     * 获得活动奖项
     *
     * @param id 编号
     * @return 活动奖项
     */
    ActivityAwardsDO getActivityAwards(Long id);

    /**
     * 获得活动奖项分页
     *
     * @param pageReqVO 分页查询
     * @return 活动奖项分页
     */
    PageResult<ActivityAwardsDO> getActivityAwardsPage(ActivityAwardsPageReqVO pageReqVO);


    void insertActivityAwards(List<ActivityAwardsDO> activityAwardsDOList);

    void deleteByActivityId(Long activityId);

    List<ActivityAwardsDO> getListByActivityId(Long activityId);

    List<ActivityAwardsDO> getListByIds(List<Long> ids);

    List<ActivityAwardsDO> getListByActivityIdAndAwardsStatus(Long activityId, String limitType);

    List<ActivityAwardsDO> getListByActivity(Long activityId);
    
}